using System;
using System.Net.Http;
using System.Text.Json;

using Refit;

using WebApiBootstrap.Contracts.Serialization;

namespace WebApiBootstrap.Client;

public class MyApiClient : IMyApiClient, IDisposable
{
    private readonly HttpClient _httpClient;

    public MyApiClient(HttpClient httpClient)
    {
        _httpClient = httpClient;
        RefitSettings refitSettings = new()
        {
            ContentSerializer = new SystemTextJsonContentSerializer(JsonSerializerOptions)
        };

        GetWeatherForecast
            = RestService.For<IGetWeatherForecastEndpoint>(_httpClient, refitSettings);
    }

    public static JsonSerializerOptions JsonSerializerOptions { get; }
        = MyApiJsonSerializerOptions.Create();

    public IGetWeatherForecastEndpoint GetWeatherForecast { get; }

    public void Dispose()
    {
        _httpClient.Dispose();
    }
}