using System;
using System.Text.Json;
using System.Text.Json.Serialization.Metadata;

namespace WebApiBootstrap.Contracts.Serialization;

public static class MyApiJsonSerializerOptions
{
    private static readonly Lazy<JsonSerializerOptions> Instance = new(
        () =>
        {
            JsonSerializerOptions? options = new JsonSerializerOptions(JsonSerializerDefaults.Web);
            Configure(options);
            options.TypeInfoResolver = new DefaultJsonTypeInfoResolver();
            options.MakeReadOnly();
            return options;
        });

    public static JsonSerializerOptions Create()
    {
        return new JsonSerializerOptions(Instance.Value);
    }

    public static void Configure(JsonSerializerOptions options)
    {
        options.WriteIndented = true;
    }
}